\ Interfaces to BIOS and XBIOS system routines

decimal

0 bios: getmpb  { l.mpb -- }

\ Device numbers for w.dev

0 constant prt:	\ The parallel printer port
1 constant aux: \ The RS232 port
2 constant con: \ The console; keyboard and screen
3 constant midi: \ The midi port
4 constant kbd: \ The keyboard port
5 constant rawcon: \ Raw console; allows printing the funny character
		   \ symbols in the first 32 font positions

1 bios: bconstat { w.dev -- w.ready? }
2 bios: bconin { w.dev -- l.char }
3 bios: bconout { w.char w.dev -- }
4 bios: rwabs { w.dev w.recno w.cnt a.buf w.rwflag -- l.err? }
5 bios: setexc { l.vec. w.vecnum -- l.oldvec }
6 bios: tickcal { -- l.ms/tick }
7 bios: getbpb { w.dev -- a.bpb }
8 bios: bcostat { w.dev -- l.ready? }
9 bios: mediach { w.dev -- l.changed? }
10 bios: drvmap { -- l.map }
11 bios: kbshift { w.mode -- l.mode }


0 xbios: initmous { l.vec a.param w.type -- }
1 xbios: ssbrk { w.amount -- }	\ Useless
2 xbios: _physBase { -- a.base }
3 xbios: _logBase { -- a.base }
4 xbios: _getRez { -- w.resolution }
5 xbios: _setScreen { w.rez a.physLoc a.logLoc -- }
6 xbios: _setPallete { a.pallete -- }
7 xbios: setColor { w.color w.colorNum -- w.oldcolor }
8 xbios: _floprd { w.cnt w.side w.track w.sect w.dev a.fill a.buf -- w.stat }
9 xbios: _flopwr { w.cnt w.side w.track w.sect w.dev l.fill a.buf -- w.stat }
10 xbios: _flopfmt
   { w.virg l.mag w.ilv w.side w.trk w.spt w.dev l.fill a.buf -- w.stat }
\ 11 obsolete
12 xbios: midiws { a.ptr w.cnt -- }
13 xbios: _mfpint { l.vector w.interrupt# -- }
14 xbios: iorec { w.dev -- a.input-record }
15 xbios: rsconf { w.scr w.tsr w.rsr w.ucr w.flowctl w.speed -- }
16 xbios: keytbl { a.capslock a.shift a.unshift -- a.keytab }
17 xbios: _random { -- l.random }
18 xbios: _protobt { w.execflag w.disktype l.serialno a.buf -- }
19 xbios: _flopver
   { w.count w.sideno w.trackno w.sectno w.devno l.filler a.buf -- w.stat }
20 xbios: scrdmp { -- }
21 xbios: cursconf { w.operand w.function -- w.conf }
22 xbios: settime { l.datetime -- }
23 xbios: gettime { -- l.datetime }
24 xbios: bioskeys { -- }
25 xbios: ikbdws { a.ptr w.cnt -- }
26 xbios: jdisint { w.intno -- }
27 xbios: jenabint { w.intno -- }
28 xbios: giaccess { w.regno b.data -- b.olddata }
29 xbios: offgibit { w.bitno -- }
30 xbios: ongibit { w.bitno -- }
31 xbios: xbtimer {a.vec w.data w.control w.timer -- }
32 xbios: dosound { a.ptr -- }
33 xbios: setprt { w.config -- w.oldconfig }
34 xbios: kbdvbase { -- l.struct }
35 xbios: kbrate { w.repeat w.initial -- w.repeat-rate }
36 xbios: _prtblk { -- }
37 xbios: vsync { -- }
38 xbios: supexec { a.codeptr -- }
39 xbios: puntaes { -- }
