PROGRAM fplot;

  CONST
    pi = 3.14159;
    {$I gemconst.pas}

  TYPE
    {$I gemtype.pas}

  VAR
    phi,theta : real;
    x,y,z : real;
    scalex,scaley,scalez : real;
    event,
    which,
    dummy,
    handle,
    wind_type : integer ;
    title : Window_Title ;
    c0,r0 : integer;
    msg : message_buffer;

  {$I gemsubs.pas}

procedure f ( var x,y,z : real);    {calculate x,y,z from r,phi,theta}

var
  r : real;

begin
  r := (sin(phi)-1)/2;        {this is the  function}
  x := r*sin(phi)*cos(theta);
  y := r*sin(phi)*sin(theta);
  z := r*cos(phi);
end;

procedure draw_f;         {draw the function line on the screen}

var
  f : string[255];

begin
  line_color(2);
  f := 'r := (sin(phi)-1)/2;';
  draw_string(c0-3*length(f),195,f);
  draw_string(20,20,'Programmed by G. F. Sellars');
  draw_string(20,30,'      with Oss Pascal');
end;

procedure project(z,x,y : real; var c,r : integer);

var                     {project 3d to 2d, swap axes}
  d : real;

begin
  d := scalez*z;
  c := round(scalex*(x+d))+c0;    { c := raster column}
  r := round(scaley*(y+d))+r0;    { r := raster row}
end;

PROCEDURE plot_curve;

var
  c,r : integer;

begin
  phi := 0;                   {plot latitude lines}
  while phi <= 2*pi do begin  {0 to 2pi will get all possible trig values}
    theta := 0;
    f(x,y,z);
    project(x,y,z,c,r);
    move_to(c,r);
    while theta <= 2*pi do begin
      f(x,y,z);
      project(x,y,z,c,r);
      line_to(c,r);
      theta := theta+pi/18;
    end;
    phi := phi+pi/18;
  end;
  theta := 0;
  while theta <= 2*pi do begin          {plot longitude lines}
    phi := 0;
    f(x,y,z);
    project(x,y,z,c,r);
    move_to(c,r);
    while phi <= 2*pi do begin
      f(x,y,z);
      project(x,y,z,c,r);
      line_to(c,r);
      phi := phi+pi/18;
    end;
    theta := theta+pi/18;
  end;
END;

procedure axis(x0,y0,z0,x1,y1,z1 :real; name : char);

var                             {plot x,y,or z axis}
  c,r : integer;

begin
  project(x0,y0,z0,c,r);
  move_to(c,r);
  project(x1,y1,z1,c,r);
  line_to(c,r);
  project(1.1*x1,1.1*y1,1.1*z1,c,r);
  draw_string(c,r,name);
end;

procedure init;

var
  i,c,r,w,h: integer;
  wr,hr : real;

begin
  handle := New_Window(0,title,0,0,0,0);
  Open_Window(handle,0,0,0,0);
  Work_Rect(handle,c,r,w,h);
  Set_Clip(c,r,w,h);
  Paint_Style(Solid);
  Paint_Color(White);
  Paint_Rect(c,r,w,h);
  c0 := (w-c) div 2;              {c0,r0 = center of screen}
  r0 := (h-r) div 2;
  r0 := r0+16;
  wr := w-c; hr := h-r;
  scalex := wr/4;
  scaley := -hr/2.5;
  scalez := -1/4;
  Line_Color(2);
  text_color(2);
  axis(-3,0,0,3,0,0,'x');
  axis(0,-1,0,0,1,0,'y');
  axis(0,0,-1,0,0,1,'z');
  Line_Color(1);
end;

BEGIN
  IF Init_Gem >= 0 THEN BEGIN
    Hide_Mouse ;
    Begin_Update ;
    init;
    plot_curve;
    draw_f;
    End_Update ;
    write(chr(7));     {ring bell when done}
    repeat
      event := get_event(e_button | e_timer,1,1,1,
                       10,
                       false,0,0,0,0,
                       false,0,0,0,0,
                       msg,dummy,dummy,dummy,dummy,dummy,dummy);
    until event & e_button <> 0;   {left mouse button clicked once}
    Show_Mouse ;
    Close_Window( handle ) ;
    Delete_Window( handle ) ;
  END;
  Exit_Gem ;
END.
