# saves Master environment in batchfile format
TMPSAVE = '/tmp/textsave.set'
SAVE -g $TMPSAVE
if "$1" != "" {
	SAVEFILE = '$1'
} else {
	SAVEFILE = 'setup.bat'
}
TMPFILE = '/tmp/textsave.tmp'
rem Saving Master working environment in $SAVEFILE
version => TMPVAR
printf  > $SAVEFILE "# TEXTSAVE ENVIRONMENT FOR %s\n" "$TMPVAR[5,]"
date => TMPVAR
time => TMPVAL
printf >> $SAVEFILE "# SAVED ON %s AT %s\n" "$TMPVAR" "$TMPVAL"
printf >> $SAVEFILE "# THIS FILE WAS MECHANICALLY GENERATED BY TEXTSAVE.BAT\n"
# kbd settings
rem kbd settings ...
kbd => TMPVAR
printf "kbd %s\n" TMPVAR >> $SAVEFILE
# rs232 settings
rem rs232 settings ...
rs232 => TMPVAR
printf "rs232 baud $TMPVAR[6] parity $TMPVAR[9] bits $TMPVAR[12]\n" >> $SAVEFILE
# history parameters
rem history parameters ...
history => TMPVAR
if "$TMPVAR[5]" = "accepting" {
	printf "history -w %d\n" $TMPVAR[8] >> $SAVEFILE
}
printf "history %d\n" $TMPVAR[4] >> $SAVEFILE
# link settings
HEADLINE = "symbolic links"
printf "%s ... \r" HEADLINE
ln > $TMPFILE
open links $TMPFILE
repeat
	getline TMPVAR
	printf "%s ... %s\eJ\r" HEADLINE "$TMPVAR[0]"
	printf "ln %s %s\n" "$TMPVAR[0]" "$TMPVAR[1]" >> $SAVEFILE
until eof links
close links
# setenv variables
printf "%s ...\eJ\n" HEADLINE
HEADLINE = "global (environment) variables"
printf "%s ... \r" HEADLINE
setenv > $TMPFILE
norec
open global_vars $TMPFILE
repeat
	getline TMPVAR
	if eof global_vars {
		break;
	}
	if "#$TMPVAR[0]#" in "#LC#NOREC#" {
		continue;
	}
	printf "%s ... %s\eJ\r" HEADLINE "$TMPVAR[0]"
	cdr -0g $TMPVAR[0] ==> TMPVAL
	if "$TMPVAL[:-2]" = "" {
		printf "setenv %s\n" "$TMPVAR[0]" >> $SAVEFILE
	} else {
		if "'" in "$TMPVAL[:-2]" {
			if "$TMPVAR[2]" != "" {
				printf "$0: global var $TMPVAR[0] should be edited\n"
				printf "# please quote \" in the next line\n" >> $SAVEFILE
			}
			printf >> $SAVEFILE '%s = "' "$TMPVAR[0]"
			rem >> $SAVEFILE $TMPVAL[:-2]"
		} else {
			printf >> $SAVEFILE "%s = '%s'\n" "$TMPVAR[0]" '$TMPVAL[:-2]'
			if "$TMPVAR[0]" = "LINES" && "$TMPVAL[:-2]" = "50" {
				printf "l50\n" >> $SAVEFILE
			}
		}
		printf "export %s\n" "$TMPVAR[0]" >> $SAVEFILE
		printf "export %s\n" "$TMPVAR[0]" >> $SAVEFILE
	}
until eof global_vars
close global_vars
# alias settings
printf "%s ...\eJ\n" HEADLINE
HEADLINE = "alias macros"
printf "%s ... \r" HEADLINE
cat >> $SAVEFILE << END_OF_WARNING
# please quote $0, $1, ..., $*, $+ and $@ in these lines
END_OF_WARNING
alias > $TMPFILE
open aliases $TMPFILE
repeat
	getline TMPVAR
	printf "%s ... %s\eJ\r" HEADLINE "$TMPVAR[0]"
	alias ==> TMPVAL $TMPVAR[0]
	if "'" in TMPVAL {
		if "$TMPVAR[2]" != "" {
			printf "$0: alias $TMPVAR[0] should be edited\n"
			printf "# please quote \" in the next line\n" >> $SAVEFILE
		}
		printf >> $SAVEFILE 'alias %s "' "$TMPVAR[0]"
		rem >> $SAVEFILE $TMPVAL[:-2]"
	} else {
		printf >> $SAVEFILE "alias %s '%s'\n" "$TMPVAR[0]" '$TMPVAL[:-2]'
	}
until eof aliases
close aliases
# set variables
printf "%s ...\eJ\n" HEADLINE
HEADLINE = "local variables"
printf "%s ... \r" HEADLINE
restore -m $TMPSAVE
set > $TMPFILE
open local_vars $TMPFILE
repeat
	getline TMPVAR
	if eof local_vars {
		break;
	}
	if "#$TMPVAR[0]#" in "#TMPSAVE#SAVEFILE#TMPFILE#TMPVAR#TMPVAL#HEADLINE#FILES#" {
		continue;
	}
	if "_" = "$TMPVAR[0:0]" {
		continue;
	}
	printf "%s ... %s\eJ\r" HEADLINE "$TMPVAR[0]"
	cdr -0 $TMPVAR[0] ==> TMPVAL
	if "'" in "$TMPVAR[1]" {
		if "$TMPVAR[2]" != "" {
			printf "$0: local var $TMPVAR[0] should be edited\n"
			printf "# please quote \" in the next line\n" >> $SAVEFILE
		}
		printf >> $SAVEFILE '%s = "' "$TMPVAR[0]"
		rem >> $SAVEFILE $TMPVAL[:-2]"
	} else {
		printf >> $SAVEFILE "%s = '%s'\n" "$TMPVAR[0]" '$TMPVAL[:-2]'
	}
until eof local_vars
close local_vars
	printf "export\n" >> $SAVEFILE
restore -g $TMPSAVE
# key bindings
printf "%s ...\eJ\n" HEADLINE
printf "key bindings ..."
printf >> $SAVEFILE "# please remove trailing blanks from the following lines\n"
key > $TMPFILE
open keys $TMPFILE
repeat
	getline TMPVAR
	if "$TMPVAR[0:0]" = "F" {
		printf >> $SAVEFILE "key  f%d %s\n" $TMPVAR[1:2] "$TMPVAR[6:39]"
		printf >> $SAVEFILE "key +f%d %s\n" $TMPVAR[42:43] "$TMPVAR[47:]"
	} else {
		printf >> $SAVEFILE "key %s %s\n" "$TMPVAR[1:2]" "$TMPVAR[6:39]"
		printf >> $SAVEFILE "key %s %s\n" "$TMPVAR[42:43]" "$TMPVAR[47:]"
	}
until eof keys
close keys
# deleting temporary files
RM -q $TMPFILE $TMPSAVE
