* Extended Copy and Append
* Copyright 1992 John M. Sieben

* I will not be responsible for any damages that occur from the use of
* this code.

* Freeware - Feel free to use any part of this code.

* This code was created using DevpacST.  You may need to adjust the two
* "include" statements on lines 19 and 691 to reflect your system setup.
* Drive B is a ramdisk on my setup.

* I want to thank all the folks who responded to my questions on GEnie.   
* If you have any comments or questions my GEnie address is J.SIEBEN.
* I welcome any critiques.

	text

	include b:\gemmacro.s

start_up:
	move.l	4(sp),a3	; get address of base page
	move.l	#stack,sp	; set program's own stack pointer
	move.l	$C(a3),d0	; length of text section
	add.l	$14(a3),d0	; length of data section
	add.l	$1C(a3),d0	; length of bss section
	add.l	#$100,d0	; program's base page
	move.l	d0,-(sp)	; push program's size onto stack
	move.l	a3,-(sp)	; push start of program's address onto stack
	clr.w	-(sp)		; push dummy word onto stack
	move.w	#$4A,-(sp)	; push Mshrink code onto stack
	trap	#1		; call GEMDOS
	lea	12(sp),sp	; pop stack
	tst	d0		; test for error
	bpl.s	start		; no error, go to start
	
	bsr	bin_to_dec	; d0 is binary number, bin_to_dec will
				; return decimal number at decimal addr

	lea	decimal,a3	; now put error # in string start_error
	lea	start_error+32,a4
.loop	move.b	(a3)+,(a4)+
	tst.b	(a3)
	bne	.loop
		
	move.l	#start_error,-(sp)
	move.w	#9,-(sp)	; display error message
	trap	#1
	addq.l	#6,sp
	
	move.w	#8,-(sp)	; press any key
	trap	#1
	addq.l	#6,sp

quit:	
	move.w	#0,-(sp)	; error code, 0 = no error
	move.w	#$4C,-(sp)	; push Pterm code onto stack
	trap	#1		; call GEMDOS - tell computer we are done
		
quit_appl:	
	appl_exit		; MACRO - tell GEM we are done
	bra.s	quit

start:
	appl_init		; MACRO - tell GEM we want to play
	move.w	d0,ap_id	; store application ID

	dc.w	$A00A		; disable mouse
	pea	title		; show title line on line 1
	move.w	#9,-(sp)
	trap	#1
	addq.l	#6,sp
	dc.w	$A009		; enable mouse
	
	move.w	#$19,-(sp)	; get current dirve
	trap	#1
	addq.w	#2,sp
	
	add.b	#65,d0		; add 65 to make drive letter
	lea	path,a3		; start building default path for
	move.b	d0,(a3)+	; file selector
	move.b	#':',(a3)+	; append colon

	clr.w	-(sp)		; get current directory
	pea	(a3)		; appending it to the default_path
	move.w	#$47,-(sp)
	trap	#1
	addq.w	#8,sp

	lea	path,a3		; find the end of path by looking for
.loop1	tst.b	(a3)+		; first null byte
	bne.s	.loop1
	
	sub.l	#1,a3		; back up one byte
	move.b	#'\',(a3)+	; append '\*.*'
	move.b	#'*',(a3)+
	move.b	#'.',(a3)+
	move.b	#'*',(a3)+
	move.b	#0,(a3)		; make sure path ends with null

get_source:	
	dc.w	$A00A		; disable mouse
	pea	trailer_1	; show what to do at bottom of screen
	move.w	#9,-(sp)
	trap	#1
	addq.l	#6,sp
	dc.w	$A009		; enable mouse
	
	clr.b	file		; will clear filename in file selector
	lea	header_1,a6	; set header for fsel_exinput
	bsr	file_selector
	tst.b	file		; did user give us a file to copy
	bne.s	check_source	; ok
	
bad_filename:
	form_alert	#1,#bad_file
				; MACRO - tell user to give filename
	bra.s	get_source	; do it till they get it right

no_wild:
	form_alert	#1,#nothing_wild
				; MACRO - tell user not to use wild cards
	bra.s	get_source	; do it till they get it right
	
check_source:
	lea	file,a3
.loop1	cmpi.b	#'?',(a3)	; check the source for wild card characters
	beq.s	no_wild
	cmpi.b	#'*',(a3)+	; increment here cause next byte could be
	beq.s	no_wild		; null
	tst.b	(a3)
	bne	.loop1
		
	lea	source,a4	; check_file will build path & name and will
	movea.l	a4,a5		; need start of source as it messes with a4
	bsr	check_file
	
	tst.w	d0		; did we find the file
	bne	bad_filename	; apparently not, try again
	
	move.l	dta+26,size
	move.l	dta+26,d0
	bsr	bin_to_dec

	lea	file,a3
	lea	sfile,a4
.loop2	move.b	(a3)+,(a4)+	; append file
	tst.b	(a3)
	bne.s	.loop2

	lea	header_2,a6	; change header for fsel_exinput
	
get_dest:
	move.b	#'C',action_flag ; this will tell LGS to use different title
	dc.w	$A00A		; disable mouse
	pea	trailer_2	; show what to do at bottom of screen
	move.w	#9,-(sp)
	trap	#1
	addq.l	#6,sp
	dc.w	$A009		; enable mouse

	bsr	file_selector

	cmp.b	#'A',source	; check to see if source and dest are 'A'
	bne.s	.jump1		; source not 'A'
	cmpi.b	#'A',path
	bne.s	.jump1		; dest not 'A'

	form_alert	#1,#both_are_a
				; MACRO - tell user source and dest are both
	bra	quit_appl	; on drive 'A', then get out of here

.jump1	tst.b	file		; did user give us a filename
	bne.s	check_dest	; yes
				; no we will use same filename as source
				; when no file is selected the fsel_exinput
				; will make the first byte of file a null
				
	lea	source,a3	; find the file portion of source
.loop2	tst.b	(a3)+		; find end of source by finding a null
	bne	.loop2
.loop3	cmpi.b	#'\',-(a3)	; now backup till we find '\'
	bne	.loop3
	addq.l	#1,a3		; add 1 to a3 to append in right place

	lea	file,a4
.loop4	move.b	(a3)+,(a4)+	; append file
	tst.b	(a3)
	bne.s	.loop4

check_dest:
	lea	dest,a4		; check_file will build path & name and will
	movea.l	a4,a5		; need start of dest as it messes with a4
	bsr	check_file
	move.w	d0,d7		; save d0 for the moment	
	tst.w	d0		; was a file found on dest
	bne.s	.jump2		; no
	
	
	lea	source,a3	; check to see if source and dest are =
	lea	dest,a4
.loop1	tst.b	(a3)		; if null we are at end of source
	beq.s	.jump1		; check if dest is null also
	cmp.b	(a3)+,(a4)+	; check each byte
	beq.s	.loop1		; if = do .loop1 again
	bra.s	.jump2		; if not = we have different source - dest
.jump1	tst.b	(a4)		; if this is null strings are same
	bne.s	.jump2		; if not continue

	form_alert	#1,#same_name
				; MACRO - tell user source and dest are same
	bra	quit_appl	; then get out of here

.jump2	bsr	free_disk_space	; get destination's free disk space
	cmp.l	size,d0		; check free space to file size
	bge	.jump3		; file will fit, let's go see if it exists
	
	cmpi.b	#65,dest	; file won't fit, is it drive A
	beq	.jump3		; yes, ok we can do it, see if it exists

	move.w	#-2,d0		; this sets up the filename for the 
	lea	sfile,a3	; alert box. I wanted the name right
.loop2	addq.w	#1,d0		; justified so we needed a way to know
	cmpi.b	#0,(a3)+	; when we moved the first character.
	bne.s	.loop2		; d0 will be 0 when we have.
	subq.l	#1,a3
	
	lea	file_to_big+18,a4
.loop3	move.b	-(a3),-(a4)	; move the filename from right to left
	dbf	d0,.loop3

	move.l	size,d0		; make size human
	bsr	bin_to_dec	; puts number in decimal address
	lea	decimal+1,a3	; the first byte in decimal is space
	lea	file_to_big+22,a4
.loop4	move.b	(a3)+,(a4)+	; move decimal to alert box
	cmpi.b	#0,(a3)		; decimal is terminated with null
	bne.s	.loop4

	move.l	space,d0	; make space human
	bsr	bin_to_dec	; puts number in decimal address
	lea	decimal+1,a3	; the first byte of decimal is space
	lea	file_to_big+48,a4
.loop5	move.b	(a3)+,(a4)+	; move decimal to alert box
	cmpi.b	#0,(a3)		; decimal is terminated with null
	bne.s	.loop5
	
	move.b	dest,file_to_big+78	; move drive letter to alert box
	
	form_alert	#1,#file_to_big
				; MACRO - file won't fit msg
	bra	quit_appl

.jump3	tst.w	d7		; we saved d0 in d7 after checking dest
	bne	.jump6		; dest didn't exist

	move.w	#-2,d0		; this sets up the filename for the 
	lea	file,a3		; alert box. I wanted the name right
.loop6	addq.w	#1,d0		; justified so we needed a way to know
	cmpi.b	#0,(a3)+	; when we moved the first character.
	bne.s	.loop6		; d0 will be 0 when we have.
	subq.l	#1,a3
	
	lea	append_or_not+18,a4
.loop7	move.b	-(a3),-(a4)	; move the filename from right to left
	dbf	d0,.loop7
	
	form_alert	#1,#append_or_not
				; MACRO - ask if they want to append to
				; or delete the existing file
	
	cmpi.w	#3,d0		; did user select cancel
	beq	quit_appl	; then quit

* action_flag will tell us what to do when we get to the meat of the program
* 'C' as initialized in data section, is to create the file on destination
* 'A' is to append to the existing file on destination
* 'O' is to overwrite or delete existing file and create a new one

	move.b	#'A',action_flag
	cmpi.w	#1,d0
	beq	.jump6
	move.b	#'O',action_flag

	move.l	space,d0	; we need to account for the free disk
	tst.l	d0		; space used by the existing file
	beq.s	.jump5		; if it is 0 it uses 0 bytes, no extra block
	divu	#1024,d0	; how many blocks does it occupy
	move.l	d0,d1		; hold this for a minute
	mulu	#1024,d0	; bytes in even numbered blocks
	
	lsr.l	#8,d1		; move the remainder into the lower
	lsr.l	#8,d1		; word
	tst.w	d1		; if it is 0 don't that's all the space
	beq.s	.jump5		; it takes
	
.jump4	add.l	#1024,d0	; otherwise it takes another block
.jump5	move.l	d0,space	; adjust space
		
.jump6	move.w	#-2,d0		; this sets up the filename for the 
	lea	sfile,a3	; alert box. I wanted the name right
.loop8	addq.w	#1,d0		; justified so we needed a way to know
	cmpi.b	#0,(a3)+	; when we moved the first character.
	bne.s	.loop8		; d0 will be 0 when we have.
	subq.l	#1,a3
	
	lea	copy_file+18,a4
.loop9	move.b	-(a3),-(a4)	; move the filename from right to left
	dbf	d0,.loop9

	move.l	size,d0		; make size human
	bsr	bin_to_dec	; puts number in decimal address
	lea	decimal+1,a3	; the first byte in decimal is space
	lea	copy_file+22,a4

.loop10	move.b	(a3)+,(a4)+	; move decimal to alert box
	cmpi.b	#0,(a3)		; decimal is terminated with null
	bne.s	.loop10

	move.l	space,d0	; make space human
	bsr	bin_to_dec	; puts number in decimal address
	lea	decimal+1,a3	; the first byte of decimal is space
	lea	copy_file+48,a4
.loop11	move.b	(a3)+,(a4)+	; move decimal to alert box
	cmpi.b	#0,(a3)		; decimal is terminated with null
	bne.s	.loop11
	
	move.b	dest,copy_file+78	; move drive letter to alert box
	
	cmpi.b	#'A',action_flag
	bne.s	.jump7
	lea	append,a3	; if action_flag is 'A' we want 'Append'
	lea	copy_file+83,a4	; to appear in the highlighted button
.loop12	move.b	(a3)+,(a4)+	; in the alert box.
	tst.b	(a3)
	bne.s	.loop12
	bra.s	.jump8
	
.jump7	cmpi.b	#'O',action_flag
	bne.s	.jump8
	lea	overwrite,a3	; if action_flag is 'O' we want 'Overwrite'
	lea	copy_file+82,a4 ; to appear in the highlighted button
.loop13	move.b	(a3)+,(a4)+	; in the alert box.
	tst.b	(a3)
	bne.s	.loop13
				; the default in the alert box is for 'Copy'
				; to appear in the highlighted button
				; in the alert box.
					
.jump8	form_alert	#1,#copy_file
	
	cmpi.w	#2,d0		; did user select cancel
	beq	quit_appl	; then quit

the_meat:
	bsr	malloc		; d5 will be set in routine
				; d5 will contain how much ram is free
	move.l	size,d6		; d6 will keep track of what has been copied
	move.l	space,d7	; d7 will keep track of (floppy) disk space

	move.w	#0,d0		; open source file for read only
	lea	source,a0
	bsr	open_file
	move.w	d0,s_handle	; save the handle
		
	cmp.b	#'A',action_flag	; when 'A' we will not be creating
	beq.s	.jump1			; file
		
	bsr	create_file	; create the file
	move.w	d0,d_handle	; save the file handle
	bra.s	read_source

.jump1	tst.l	d7		; if disk is already full
	beq.s	disk_full	; we got to do somthing about it
	
	move.w	#1,d0		; open dest file for write only
	lea	dest,a0
	bsr	open_file
	move.w	d0,d_handle	; save the handle
	
	bsr	seek_file	; position file pointer to end of file

read_source:
* d5 contains how much ram is free
* d6 keeps track of what is left to be copied
* d7 will keeps track of (floppy) disk space
* for the read/write operation we will want to use the smallest value 
* of d5,d6 or d7

	move.l	d7,d0		; set d0 with d7
	cmp.l	d7,d6		; is d7 less than d6
	bge.s	.jump1		; yes
	move.l	d6,d0		; d6 is less, set d0 with d6
	cmp.l	d6,d5		; is d6 less than d5
	bge.s	.jump2		; yes                             d6 is less
	move.l	d5,d0		; set d0 with d5                  d5 is less
	bra.s	.jump2
.jump1	cmp.l	d7,d5		; d7 less than d5
	bge.s	.jump2		;                                 d7 is less
	move.l	d5,d0		; set d0 with d5                  d5 is less

.jump2	bsr	read_file	; read the file
	cmpi.l	#0,d0		; d0 contains bytes read and will write
	beq	close_up_shop

	bsr	write_file	; write the file
	sub.l	d0,d6		; subtract what was written from file size
	tst.l	d6		; are we done
	beq.s	close_up_shop	; yes, time to quit
	sub.l	d0,d7		; subtract what was written from disk space
	tst.l	d7		; is the disk full
	bne	read_source	; no, go do it again
	
	move.w	d_handle,d0	; close destination file
	bsr	close_file

disk_full:
	form_alert	#1,#disk_is_full
				; MACRO - tell user disk is full
	cmpi.w	#2,d0		; did user select cancel
	beq.s	close_up_source	; then quit
		
	bsr	free_disk_space	; get destination's free disk space
	cmpi.l	#0,space	; is there free space on this disk
	beq.s	disk_full	; tell user to insert another disk
	move.l	space,d7	; d7 will keep track of (floppy) disk space
		
	bsr	create_file	; create the file
	move.w	d0,d_handle	; save the file handle
	bra.s	read_source	; do it again

close_up_shop:					
	move.w	d_handle,d0	; close destination file
	bsr	close_file
close_up_source:
	move.w	s_handle,d0	; close source file
	bsr	close_file
	bsr	mfree		; release allocated memory
	bra	quit_appl
			
* ------------
* Subroutines
* ------------

bin_to_dec:                 
	lea	decimal,a0	; put address 'decimal' in a0
	lea	subtrahend,a1   ; put address of subtrahend table in a1
	move.l	(a1)+,d1	; put first subtrahend in d1.
	move.b	#$30,d2		; Initialize d2 counter to ASCII '0'
	tst.l	d0		; binary number zero, positive, or negative
	beq.s	zero		; number is 0
	bpl.s	positive	; number is positive
	move.b	#$2D,(a0)+	; put minus sign in 'decimal' # is negative
	neg.l	d0		; change binary number from neg to pos
	bra.s	leading_zeros
positive:
	move.b	#$20,(a0)+	; put a space in 'decimal'
leading_zeros:
	sub.l	d1,d0		; subtract subtrahand from binary number
	bpl.s	subtract	; done when d0 is positive
	add.l	d1,d0		; restore binary number
	move.l	(a1)+,d1	; get next subtrahend
	bra.s	leading_zeros
subtract:
	addq.b	#1,d2		; increment subtractions counter
	sub.l	d1,d0		; subtract subtrahend from binary number
	bpl.s	subtract	; loop until d0 becomes negative
	move.b	d2,(a0)+	; put ASCII digit in 'decimal'
loop_setup:
	add.l	d1,d0		; restore bianry number
	move.b	#$2F,d2		; initialize d2 counter to ASCII '/'
				;              1 less than ASCII '0'
	move.l	(a1)+,d1	; get next subtrahend
	bne.s	subtract	; loop until subtrahend = 0
	move.b	#0,(a0)		; terminate 'decimal' with a null
	rts
zero:
	move.b	#$20,(a0)+	; put a space in 'decimal'
	move.b	d2,(a0)+	; put an ASCII zero in 'decimal'
	move.b	#0,(a0)		; terminate 'decimal' with a null.
	rts

* ----------

file_selector:
	move.w	#91,control	; code for fsel_exinput
	cmpi.w	#$140,global	; is gem version number = or > $140
	bge.s	.jump1		; yes, use fsel_exinput

	move.w	#90,control	; code for fsel_input
.jump1	move.w	#0,control+2	; set up control array
	move.w	#2,control+4
	move.w	#4,control+6	; normally 2 for 90, 3 for 91, 4 for LGS
	move.w	#0,control+8
	move.l	#path,addr_in	; give it path
	move.l	#file,addr_in+4	; filename
	cmp.b	#'C',action_flag ; if 'S' then display 'Source' in box
	beq.s	.jump2
	move.l	#lg_title1,addr_in+8 ; display 'Source'
	bra.s	.jump3
.jump2	move.l	#lg_title2,addr_in+8 ; display 'Destination'	
.jump3	move.l	#lg_title3,addr_in+12 ; second 12 character string for LGS
	
	move.l	#aes_params,d1	; call aes, give aes_params
	move.l	#$C8,d0		; magic number
	trap	#2		; do it
			
.jump4	dc.w	$A00A		; disable mouse
	pea	clear		; clear screen below first line
	move.w	#9,-(sp)
	trap	#1
	addq.l	#6,sp
	dc.w	$A009		; enable mouse

	cmpi.w	#0,int_out+2	; did user select cancel
	beq	quit_appl	; we are out of here
	rts

* ----------

check_file:
	lea	path,a3		; move path to source
.loop1	move.b	(a3)+,(a4)+
	tst.b	(a3)		; end of path is null
	bne.s	.loop1
.loop2	cmp.b	#'\',-(a4)	; now backup to first '\'
	bne.s	.loop2
	addq.l	#1,a4		; add 1 to set up for appending file
	
	lea	file,a3
.loop3	move.b	(a3)+,(a4)+	; append file
	tst.b	(a3)
	bne.s	.loop3
	move.b	#0,(a4)		; make sure it is terminated with null
		
	pea	dta		; need to set disk transfer address
	move.w	#$1A,-(sp)	; so we can find out how big the file
	trap	#1		; is when we see if it exists
	addq.l	#6,sp
	
	move.w	#0,-(sp)	; see if file exists
	move.l	a5,-(sp)	; a5 holds the start of path & name
	move.w	#$4E,-(sp)
	trap	#1
	addq.l	#8,sp
	rts
	
* ----------

free_disk_space:
	clr.w	d0		; set up drive number for getting free
	move.b	dest,d0		; disk space
	sub.w	#64,d0		; drive # is same as setdrv + 1
	
	move.w	d0,-(sp)	; 0 would be current drive
	pea	fds
	move.w	#$36,-(sp)	; get free disk space (fds)
	trap	#1
	addq.l	#8,sp

	move.l	fds+8,d0	; bytes in sector
	move.l	fds+12,d1	; sectors in cluster
	mulu	d1,d0		; multiply bytes * sectors
	move.l	fds,d1		; number of clusters
	mulu	d1,d0		; multiply bytes * sectors * clusters
	move.l	d0,space	; save free disk space	
	rts

* ------------

malloc:
	move.l	#-1,-(sp)	; get free ram
	move.w	#$48,-(sp)
	trap	#1
	addq.l	#6,sp
	
	cmpi.l	#17408,d0	; if it is less than 17408 we will try
	bmi.s	.jump1		; to work with 1024 copy_buffer
	subi.l	#16384,d0	; save 16384 for AES
	divu	#1024,d0	; make copy buffer on a 1K boundry
	mulu	#1024,d0
	bra.s	.jump2
.jump1	move.l	#1024,d0
.jump2	move.l	d0,d5		; save amount of memory to d5
	move.l	d0,-(sp)
	move.w	#$48,-(sp)	; allocate memory
	trap	#1
	addq.l	#6,sp
	tst.l	d0
	bmi	gemdos_error
	move.l	d0,copy_buffer
	rts

* ------------

mfree:
	move.l	copy_buffer,-(sp)
	move.w	#$49,-(sp)
	trap	#1
	addq.l	#6,sp
	tst.l	d0
	bne	gemdos_error
	rts

* ------------

create_file:
	move.w	#0,-(sp)	; file should have read/write status
	pea	dest		; use the dest path and filename
	move.w	#$3C,-(sp)
	trap	#1		; create the file
	addq.l	#8,sp
	tst.l	d0		; was there an error
	bmi	gemdos_error	; something is wrong
	rts

* ------------

close_file:
	move.w	d0,-(sp)	; pass handle of file to close
	move.w	#$3E,-(sp)
	trap	#1		; close the file
	addq.l	#4,sp
	tst.l	d0		; was there an error
	bmi.s   gemdos_error	; something is wrong
	rts

* ------------
	
open_file:
	move.w	d0,-(sp)	; when reading source, file should only be
				; opended in read mod, destination may need
				; to be read but will need write
	move.l	a0,-(sp)	; pass the address of path and filename
	move.w	#$3D,-(sp)
	trap	#1		; open the file
	addq.l	#8,sp
	tst.l	d0		; was there an error
	bmi.s	gemdos_error	; something is wrong
	rts

*-------------

seek_file:
	move.w	#2,-(sp)	; get to the end of the file
	move.w	d0,-(sp)	; handle of file
	move.l	#0,-(sp)	; don't want to seek any bytes from end
	move.w	#$42,-(sp)
	trap	#1		; position on the end
	lea	10(sp),sp
	tst.w	d0		; was there an error
	bmi.s	gemdos_error	; something is wrong
	rts
	
*-------------

read_file:
	move.l	copy_buffer,-(sp) ; push copy_buffer address on stack
	move.l	d0,-(sp)	; pass number of bytes to write
	move.w	s_handle,-(sp)	; source file handle
	move.w	#$3F,-(sp)
	trap	#1		; read the file
	lea	12(sp),sp
	tst.l	d0		; was there an error
	bmi.s	gemdos_error	; something is wrong
	rts

*-------------

write_file:
	move.l	copy_buffer,-(sp) ; push copy_buffer address on stack
	move.l	d0,-(sp)	; pass number of bytes to write
	move.w	d_handle,-(sp)	; destination file handle
	move.w	#$40,-(sp)
	trap	#1		; write to the file
	lea	12(sp),sp
	tst.l	d0		; was there an error
	bmi.s	gemdos_error	; something is wrong
	rts

* -------------

gemdos_error:
	form_error	d0	; MACRO - let user know there was an error
	bra	quit_appl	; stop the program
				
* ------------
* AES library
* ------------
	
	include b:\aeslib.s

* -------------
* Data Section
* -------------
	data
	even

title:		dc.b 27,'E',27,'f',27,'p'
		dc.b 189,' 1992 John M. Sieben'
		dcb.b 7,' '
		dc.b 'Extended Copy and Append'
		dcb.b 20,' '
		dc.b 'Freeware'
		dc.b 27,'q',13,10,0
	
clear:		dc.b 27,'Y',33,32,27,'J',0
	
start_error:	dc.b 'Error on start up, error number      Press any key'
		dc.b 13,10,0

nothing_wild:	dc.b '[2][ |'
		dc.b 'Wild cards (? & *) are not|'
		dc.b 'allowed.  Application will|'
		dc.b ' copy one file at a time.]'
		dc.b '[  OK  ]'

bad_file:	dc.b '[2][This application cannot|'
		dc.b 'find the folder or file|'
		dc.b 'you just tried to access.]'
		dc.b '[  OK  ]'

both_are_a:	dc.b '[2][ |'
		dc.b 'You have selected the|'
		dc.b 'source and destination|'
		dc.b '     as drive A.]'
		dc.b '[Cancel]'

same_name:	dc.b '[2][ |'
		dc.b '   You have selected a|'
		dc.b 'source path and file the |'
		dc.b 'same as the destination.]'
		dc.b '[Cancel]'

file_to_big:	dc.b '[2][ |'
		dc.b '             is          |'
		dc.b 'bytes. There is          |'
		dc.b 'bytes free on drive  .|'
		dc.b '  File will not fit.]'
		dc.b '[Cancel]'

append_or_not:	dc.b '[2][ |'
		dc.b '             already exists.|'
		dc.b '  Do you want to append or|'
		dc.b '    overwrite this file.]'
		dc.b '[Append|Overwrite|Cancel]'

copy_file:	dc.b '[2][ |'
		dc.b '             is          |'
		dc.b 'bytes. There is          |'
		dc.b 'bytes free on drive  .]'
		dc.b '[  Copy   |Cancel]'

disk_is_full:	dc.b '[2][ |'
		dc.b 'Disk in drive A is full. |'
		dc.b '  Insert another disk.]'
		dc.b '[  OK  |Cancel]'

trailer_1:	dc.b 27,'Y',55,59
header_1:	dc.b 'Select source file to copy',0
trailer_2:	dc.b 27,'Y',55,58
header_2:	dc.b 'Select destination path/file',0

lg_title1:	dc.b 'Source',0
lg_title2:	dc.b 'Destination',0
lg_title3:	dc.b 'Path/File',0
action_flag:	dc.b 'S'
append:		dc.b 'Append',0
overwrite:	dc.b 'Overwrite',0

subtrahend:	dc.l 1000000000,100000000,10000000,1000000,100000
		dc.l 10000,1000,100,10,1,0
			
* ------------
* BSS Section
* ------------

	bss
	even			; make sure we are at an even address
ap_id:		ds.w	1
path:		ds.l	30
file:		ds.w	14
sfile:		ds.w	14
source:		ds.w	44
dest:		ds.w	44
dta:		ds.l	11
fds:		ds.l	4
space:		ds.l	1
size:		ds.l	1
decimal:	ds.l	3
copy_buffer:	ds.l	1
free_ram:	ds.l	1
s_handle:	ds.w	1
d_handle:	ds.w	1

		ds.l	32	; stack
stack:		ds.l	0	; address of stack

	end               
