GNU Tar 1.10 Port for the Atari ST with MiNT (and without)
==========================================================

Well, I decided it was time I had a full fledged TAR that could handle 
compressed archives rather than uncompressing and then untaring. So, I got
the latest version of GNU Tar I could, which is v1.10, and started to port it
to the Atari. 

I essentially use this program with MiNT, as MiNT provides all the facilities
neccessary for me to use this program successfully. Supporting pipes are
essential for the compress/uncompress function of GNU Tar to work, otherwise
all the other functions should work under standard TOS.

Included in the binaries part of the this port is also my own compiled version
of compress v4.0. All other versions of compress that I found opened the
stdin/stdout functions in ASCII mode rather than binary and confused GNU Tar
when using compressed archives. The one included has been tested to great
length and shouldn't cause any problems, just make sure that its in your 
default PATH statement in your environment.

There is also an environmental variable within GNU Tar to set a default 
archive. By default through compiling this is set to 'tar.out', but you can
change this by setting the environmental variable 'TAPE' to anything.

This version has been compiled with GNU GCC v1.40 and the MiNT libraries at
patchlevel 19. To take full advantage of GNU Tar, use MiNT v0.9x, which has
the ability to support symbolic links within the kernel.

I must pass a lot of credit onto Eric Smith for all the work he has put into
making MiNT, for which without this and the libraries, this port would have
been so much harder to do.

Release Additions for SCSI Tape Streamer Extensions (18/03/92)
==============================================================

With this port of GNU Tar it is now possible to talk to SCSI tape
streamers connected through the DMA bus(via a host adapter). To access such
a streamer a bios driver must be installed, this driver is called TapeBIOS.
TapeBIOS is a totally separate package, that contains programmers docs, include
files, library code and support programs to help programmers use the new bios
device, through standard trap function calls. In all the package is about 190K
of code, so if you need SCSI streamer support then get TapeBIOS.

In this version there is only one problem I know of so far. This is the ability
to use any of GNU Tar's append or update features on SCSI Tape Streamers.
The sole reason for this is that not all tape drives support backspacing the
tape drive, and mine doesn't. So I couldn't test even if I did implement it.
If anyone is willing to supply a fix please let me know.

Using Compressed archives on the Tape Streamer is not yet supported, if you
execute any command that requires this, GNU Tar will hang. If you want an
explanation why, then check out number 1. in the BUGS file.

To access the Tape Drive from GNU Tar use '=tape' as the output archive.
First you must install the TapeBIOS device driver. Then use commands
like this to access the tape drive.
i.e.
		gtar cvf =tape *	

Will create, and verbosely list, the archive on the tape and all files in the
current directory and subdirectories will be put into the archive on tape.

NOTE: If the devicename '=tape' has any string whatsoever before it then GNU
tar will assume access to the tape drive. (i.e. if device is 'atari=tape', then
gtar will treat this device as though you want to access the tape unit.)

You may like to set the environmental variable 'TAPE' to '=tape', so that a
simple command like 'gtar vt' would list the archive on the tape drive
verbosely. BE CAREFUL when setting this, you must say 'setenv TAPE="=tape"',
or what ever the equivalent of your shell is. i.e. you must enclose '=tape'
within quotes.

The TapeBIOS installs an XBRA id of 'TAPE' into trap #10, and also a cookie
in the cookie jar with an id again of 'TAPE' with the version number. When
writing your own code for use with TapeBIOS, best method is to check the
cookie jar for the presence of the driver or you can make a trap #10 call with
command $ACE. If the return code is $ACE, then the driver isn't present.

Please let me know of any inconsistencies you find using GNU Tar and I'll 
attempt to fix them.

Alan Hourihane
email: alanh@logitek.co.uk
18/3/92
